/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Download Sort.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


// old function
var __foundHeaderInfo = window.foundHeaderInfo;

window.addEventListener("load", downsortinit, true);
//window.addEventListener("unload", downsortclose, false);
var ds_datasource;
//var ds_sink;
var ds_remote;

var ds_RDFC = '@mozilla.org/rdf/container;1';
ds_RDFC = Components.classes[ds_RDFC].createInstance();
ds_RDFC = ds_RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var ds_RDFCUtils = '@mozilla.org/rdf/container-utils;1';
ds_RDFCUtils = Components.classes[ds_RDFCUtils].getService();
ds_RDFCUtils = ds_RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var ds_RDF = '@mozilla.org/rdf/rdf-service;1';
ds_RDF = Components.classes[ds_RDF].getService();
ds_RDF = ds_RDF.QueryInterface(Components.interfaces.nsIRDFService);
	
//var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);


function downsortinit() {
	
  	window.removeEventListener("load", downsortinit, true);
  	window.foundHeaderInfo = ds_foundHeaderInfo;
	
	//toJavaScriptConsole();
	
	var gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var profile = Components.classes["@mozilla.org/profile/manager;1"].getService(Components.interfaces.nsIProfileInternal);
	var gProfileDirURL = gIOService.newFileURI(profile.getProfileDir(profile.currentProfile));
	
	var rootnode = ds_RDF.GetResource("NC:ExtensionRoot");
	ds_datasource = ds_RDF.GetDataSourceBlocking("file://" + gProfileDirURL.path + "downsort.rdf");
	 
	try {  
      ds_RDFC.Init(ds_datasource,rootnode);
    } catch (e) {
      ds_RDFCUtils.MakeSeq(ds_datasource,rootnode);
      ds_RDFC.Init(ds_datasource,rootnode);
      
    }
		
	ds_remote = ds_datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	
/*	if (ds_remote.loaded) { 
		aConsoleService.logStringMessage("the datasource was already loaded!");
	} 
	else { 
		aConsoleService.logStringMessage("the datasource wasn't loaded, but it's loading now!");
	}
	ds_remote.Flush();
	// RDF/XML Datasources are all nsIRDFXMLSinks  
	ds_sink = ds_datasource.QueryInterface(Components.interfaces.nsIRDFXMLSink);  
	// Attach the observer to the datasource-as-sink  
	ds_sink.addXMLSinkObserver(ds_rdfObserver);  
*/	
	
}

// This is the object that will observe the RDF/XML load's progress 
/*var ds_rdfObserver = { 
	onBeginLoad: function(aSink) {}, 
	onInterrupt: function(aSink) {}, 
	onResume: function(aSink) {}, 
	onEndLoad: function(aSink) { 
		aConsoleService.logStringMessage("done!");
		
	}, 
	onError: function(aSink, aStatus, aErrorMsg) { 
		aConsoleService.logStringMessage("error! " + aErrorMsg); 
	} 

};
*/

function downsortclose() {
	//window.removeEventListener("unload", downsortclose, false);
	//sink.removeXMLSinkObserver(ds_rdfObserver);	
}

// Replacement function
function ds_foundHeaderInfo(aSniffer, aData, aSkipPrompt) {
	var contentType = aSniffer.contentType;
	var contentEncodingType = aSniffer.contentEncodingType;
	
	var shouldDecode = false;
	// Are we allowed to decode?
	try {
	const helperAppService =
	  Components.classes["@mozilla.org/uriloader/external-helper-app-service;1"].
	    getService(Components.interfaces.nsIExternalHelperAppService);
		var url = aSniffer.uri.QueryInterface(Components.interfaces.nsIURL);
		var urlExt = url.fileExtension;
		if (helperAppService.applyDecodingForType(contentType) &&
		    (!urlExt || helperAppService.applyDecodingForExtension(urlExt))) {
		  shouldDecode = true;
		}
	}
	catch (e) {
	}

	var isDocument = aData.document != null && isDocumentType(contentType);
	if (!isDocument && !shouldDecode && contentEncodingType) {
		// The data is encoded, we are not going to decode it, and this is not a
		// document save so we won't be doing a "save as, complete" (which would
		// break if we reset the type here).  So just set our content type to
		// correspond to the outermost encoding so we get extensions and the like
		// right.
		contentType = contentEncodingType;
	}
	
	// Determine what the 'default' string to display in the File Picker dialog 
	// should be. 
	var defaultFileName = getDefaultFileName(aData.fileName, 
	                                       aSniffer.suggestedFileName, 
	                                       aSniffer.uri,
	                                       aData.document);

	var defaultExtension = getDefaultExtension(defaultFileName, aSniffer.uri, contentType);
	var defaultString = getNormalizedLeafName(defaultFileName, defaultExtension);
	
	const prefSvcContractID = "@mozilla.org/preferences-service;1";
	const prefSvcIID = Components.interfaces.nsIPrefService;                              
	var prefs = Components.classes[prefSvcContractID].getService(prefSvcIID).getBranch("browser.download.");
	
	const nsILocalFile = Components.interfaces.nsILocalFile;
	const lfContractID = "@mozilla.org/file/local;1";
	
	var dir = null;
	//aConsoleService.logStringMessage(defaultExtension);
	try {
		defaultExtension = defaultExtension.toLowerCase();
		var aSource = ds_RDF.GetResource("NC:ExtensionRoot:" + defaultExtension);  // if this fails, it will skip the rest of the try block and do the error block which contains the default
		var aProp = ds_RDF.GetResource("http://home.netscape.com/NC-rdf#location");
		var autoLocation = ds_datasource.GetTarget(aSource, aProp, true);
		autoLocation = autoLocation.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
		
		var aProp2 = ds_RDF.GetResource("http://home.netscape.com/NC-rdf#action");
		var autoAction = ds_datasource.GetTarget(aSource, aProp2, true);
		autoAction = autoAction.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
		
		//aConsoleService.logStringMessage(autoLocation);
		//aConsoleService.logStringMessage(autoAction);
		
		var dir = Components.classes[lfContractID].createInstance(nsILocalFile);
		dir.initWithPath(autoLocation);
		var testdir = Components.classes[lfContractID].createInstance(nsILocalFile);
		testdir.initWithPath(autoLocation);
		testdir.append(defaultString);
		
		aSkipPrompt = true;
		
		if (testdir.exists()) {
			//aConsoleService.logStringMessage("alreadyexists");
  	  		if (autoAction == "selectCanc") {
  	  			var dlpref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  	  			
  	  			try {
  	  				var soundpref = dlpref.getBoolPref("downsort.cancel.sound");
  	  				var showpref = dlpref.getBoolPref("downsort.cancel.show");
  	  			}
  	  			catch (e) {}
  	  			
  	  			if (soundpref) {
	  	  			// Play a sound
	  	  			var kSOUNDContractID = "@mozilla.org/sound;1";
	  				var kSOUNDIID = Components.interfaces.nsISound;
	  				var sound = Components.classes[kSOUNDContractID].createInstance(kSOUNDIID);
	  				sound.beep();
	  			}
	  			
	  			if (showpref) {
	  				dir.reveal();
	  			}
  	  			//aConsoleService.logStringMessage("canceling");
  	  			return;
  	  		}
  	  		if (autoAction == "selectPrompt") {
    			aSkipPrompt = false;
    		}
    		else {
    			dir.append(defaultString); 
    		}
  	  		if (autoAction == "selectIncr") {
    			dir.createUnique(0, 0644);
    		}
    		
    	}
    	else {
    		dir.append(defaultString); 
    	}

	}
	catch (e) {
	  dir = prefs.getComplexValue("dir", nsILocalFile);
	}
	//aConsoleService.logStringMessage(dir.path);
	var filterIndex = 0;
	var file;
	if (!aSkipPrompt) {
		var fp = makeFilePicker();
		var titleKey = aData.filePickerTitle || "SaveLinkTitle";
		var bundle = getStringBundle();
		fp.init(window, bundle.GetStringFromName(titleKey), 
		        Components.interfaces.nsIFilePicker.modeSave);
		
		appendFiltersForContentType(fp, contentType,
		                            isDocument ? MODE_COMPLETE : MODE_FILEONLY);  
		
		if (dir)
		  fp.displayDirectory = dir;
		
		if (isDocument) {
		  try {
		    fp.filterIndex = prefs.getIntPref("save_converter_index");
		  }
		  catch (e) {
		  }
		}
		
		fp.defaultExtension = defaultExtension;
		fp.defaultString = defaultString;
		
		if (fp.show() == Components.interfaces.nsIFilePicker.returnCancel || !fp.file)
		  return;
		
		var useDownloadDir = false;
		try {
		  useDownloadDir = prefs.getBoolPref("useDownloadDir");
		}
		catch(ex) {
		}
		
		if (!useDownloadDir) {
		  var directory = fp.file.parent.QueryInterface(nsILocalFile);
		  prefs.setComplexValue("dir", nsILocalFile, directory);
		}
		fp.file.leafName = validateFileName(fp.file.leafName);
		filterIndex = fp.filterIndex;
		file = fp.file;
    }
	else {
		// don't need this?
		//dir.append(defaultString);
		file = dir;
	}

	if (isDocument) 
		prefs.setIntPref("save_converter_index", filterIndex);

	// If we're saving a document, and are saving either in complete mode or 
	// as converted text, pass the document to the web browser persist component.
	// If we're just saving the HTML (second option in the list), send only the URI.
	var source = (isDocument && filterIndex != 1) ? aData.document : aSniffer.uri;
	var persistArgs = {
		source      : source,
		contentType : (isDocument && filterIndex == 2) ? "text/plain" : contentType,
		target      : file,
		postData    : aData.document ? getPostData() : null,
		bypassCache : aData.bypassCache
	};
	var persist = makeWebBrowserPersist();

	// Calculate persist flags.
	const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
	const flags = nsIWBP.PERSIST_FLAGS_NO_CONVERSION | nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
	if (aData.bypassCache)
    	persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
	else 
    	persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_FROM_CACHE;

	if (shouldDecode)
    	persist.persistFlags &= ~nsIWBP.PERSIST_FLAGS_NO_CONVERSION;
    
	// Create download and initiate it (below)
	var dl = Components.classes["@mozilla.org/download;1"].createInstance(Components.interfaces.nsIDownload);
	if (isDocument && filterIndex != 1) {
		// Saving a Document, not a URI:
		var filesFolder = null;
		if (persistArgs.contentType != "text/plain") {
			// Create the local directory into which to save associated files. 
			filesFolder = Components.classes[lfContractID].createInstance(nsILocalFile);
			filesFolder.initWithPath(persistArgs.target.path);
			
			var nameWithoutExtension = filesFolder.leafName;
			nameWithoutExtension = nameWithoutExtension.substring(0, nameWithoutExtension.lastIndexOf("."));
			var filesFolderLeafName = getStringBundle().formatStringFromName("filesFolder",
			                                                               [nameWithoutExtension],
			                                                               1);

      		filesFolder.leafName = filesFolderLeafName;
    	}
      
		var encodingFlags = 0;
		if (persistArgs.contentType == "text/plain") {
		  encodingFlags |= nsIWBP.ENCODE_FLAGS_FORMATTED;
		  encodingFlags |= nsIWBP.ENCODE_FLAGS_ABSOLUTE_LINKS;
		  encodingFlags |= nsIWBP.ENCODE_FLAGS_NOFRAMES_CONTENT;        
		}
    
    
		const kWrapColumn = 80;
		dl.init(aSniffer.uri, persistArgs.target, null, null, null, persist);
		persist.saveDocument(persistArgs.source, persistArgs.target, filesFolder, 
		                     persistArgs.contentType, encodingFlags, kWrapColumn);
  	} else {
    dl.init(source, persistArgs.target, null, null, null, persist);
    persist.saveURI(source, null, null, persistArgs.postData, null, persistArgs.target);
  }
}